<template>
    <div>
        <v-container>
            <v-row>
                <v-col>
                    <v-row>
                        <v-col v-for="lan in langsMenu" :key="lan.id">
                            <span>{{ lan.language }}</span>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col v-for="lan in langsMenu" :key="lan.id"   class="table-titless">
                            <v-text-field
                                :label="lan.language"
                                :value="
                                    langsCategoryFromComponent.get(lan.id)
                                        ? langsCategoryFromComponent.get(lan.id).text
                                        : undefined
                                "
                                @input="input => changeLangText(input, lan.id, lan.language)"
                            ></v-text-field>
                        </v-col>
                    </v-row>
                </v-col>
            </v-row>
        </v-container>
    </div>
</template>

<script lang="ts">
    import { Component, Prop, Vue } from 'vue-property-decorator';
    import { LangMenu } from '@/model/menu/LangMenu';
    import { db } from '@/config/firebase';
    import { CATEGORIES, CATEGORY_LANGS_NAME, MENUS, SUBCATEGORIES } from '@/config/collectionsName';
    import { serializeLangText } from '@/config/serializables';
    import { LangText } from '@/model/LangText';

    @Component
export default class SubcategoryLanguages extends Vue {
    @Prop({ default: () => [] })
    langsMenu!: LangMenu[];
    @Prop({ default: '' })
    menuId!: string;
    @Prop({ default: '' })
    subcategoId!: string;
    @Prop({ default: '' })
    categoryId!: string;

    langsSubCategoryFromFire: LangText[] = [];
    langsCategoryFromComponent: Map<string, LangText> = new Map();

    async created() {
        await this.$bind(
            'langsSubCategoryFromFire',
            db
                .collection(MENUS)
                .doc(this.menuId)
                .collection(CATEGORIES)
                .doc(this.categoryId)
                .collection(SUBCATEGORIES)
                .doc(this.subcategoId)
                .collection(CATEGORY_LANGS_NAME),
            { serialize: serializeLangText }
        );
        this.langsCategoryFromComponent = new Map();
        this.langsSubCategoryFromFire.forEach(langCategory =>
            this.langsCategoryFromComponent.set(langCategory.id, langCategory)
        );
    }
    changeLangText(input: string, langId: string, lang: string) {
        this.langsCategoryFromComponent.set(langId, new LangText(langId, lang, input));
        this.updateSubCategory(new LangText(langId, lang, input), this.menuId, this.categoryId, this.subcategoId);
    }
    updateSubCategory(newlanguage: LangText, menuId: string, categoryId: string, subcategoryId: string) {
        const isValid = true;
        if (isValid) {
            this.$emit('updateSubLanguages', newlanguage, menuId, categoryId, subcategoryId);
            //this.$emit('setMessage', 'DATOS GUARDADOS', 'success');
        }
    }
}
</script>

<style type="text/css">

</style>
